DEFINT A-Z
DECLARE SUB ColorWithMusic (Byte$)
DECLARE SUB Page1TopRow ()
CONST Num$ = "0123456789"
COMMON SHARED Colr
SCREEN 0, , 1, 0
_FULLSCREEN
VIEW PRINT
COLOR 7, 0
CLS
SCREEN 0, , 0, 0
VIEW PRINT
COLOR 14, 0
CLS
LOCATE 1, 25
COLOR 9
PRINT "FILEBYTE HEX MUSIC & COLOR SHOW"
LOCATE 3, 1, 1
COLOR 15
PRINT "FileName [d:][path\][filename]: ";
COLOR 14
LINE INPUT ; FileName$
FileName$ = LTRIM$(RTRIM$(FileName$))
IF FileName$ = "" THEN
    SCREEN 0, , 1, 1
    COLOR 7, 0
    CLS
    SCREEN 0, , 0, 0
    COLOR 7, 0
    CLS
    SYSTEM
END IF
IF _FILEEXISTS(FileName$) = 0 THEN
    RUN
END IF
Lab1:
VIEW PRINT 19 TO 24
COLOR 14, 0
CLS
COLOR 15
PRINT "Note Length (1 through 64th): ";
COLOR 14
LINE INPUT ; Length$
Length$ = LTRIM$(RTRIM$(Length$))
IF Length$ = "" THEN
    RUN
END IF
FOR X = 1 TO LEN(Length$)
    IF INSTR(Num$, MID$(Length$, X, 1)) = 0 THEN
        GOTO Lab1
    END IF
NEXT X
IF VAL(Length$) < 1 OR VAL(Length$) > 64 THEN
    GOTO Lab1
END IF
Length = VAL(Length$)
Lab2:
VIEW PRINT 22 TO 24
COLOR 14, 0
CLS
COLOR 15
LOCATE 22, 1
PRINT "Music Tempo (32 through 255): ";
COLOR 14
LINE INPUT ; Tempo$
Tempo$ = LTRIM$(RTRIM$(Tempo$))
IF Tempo$ = "" THEN
    GOTO Lab1
END IF
FOR X = 1 TO LEN(Tempo$)
    IF INSTR(Num$, MID$(Tempo$, X, 1)) = 0 THEN
        GOTO Lab2
    END IF
NEXT X
IF VAL(Tempo$) < 32 OR VAL(Tempo$) > 255 THEN
    GOTO Lab2
END IF
Tempo = VAL(Tempo$)
TempoLength = Tempo * Length
Ticks! = 3822 / TempoLength
Ticks! = Ticks! / 18
IF Flag THEN
    GOTO FlagOn
END IF
Lab3:
IF Flag THEN
    VIEW PRINT
    LOCATE 6, 1
    COLOR 15
    PRINT "File Length:";
    COLOR 14
    PRINT LOF(FileName); "Decimal, "; HEX$(LOF(FileName)); " Hexadecimal Bytes"
    LOCATE 9, 1
    COLOR 15
    PRINT "Last Byte Played:";
    COLOR 14
    PRINT LOC(FileName) - 1; "Decimal, "; HEX$(LOC(FileName) - 1); " Hexadecimal";
    LOCATE 12, 1
    COLOR 15
    PRINT "Note Duration (L, N or S): ";
    COLOR 14
    IF Duration$ = "MN" THEN
        PRINT "Normal (7/8 Time)  ";
    ELSEIF Duration$ = "MS" THEN
        PRINT "Staccato (3/4 Time)";
    ELSE
        PRINT "Legato (1/1 Time)  ";
    END IF
    LOCATE 15, 1
    COLOR 15
    PRINT "Note Octave (0 through 4):";
    COLOR 14
    PRINT Octave
    LOCATE 17, 1
    PRINT STRING$(80, 196);
    GOTO Lab2
END IF
FileName = FREEFILE
OPEN FileName$ FOR BINARY AS FileName LEN = 1
VIEW PRINT
Counter& = 0
Lines = 0
Colr = 0
Paragraph& = 0
SCREEN 0, , 1, 1
CLS
Page1TopRow
COLOR 0, 7
PRINT STRING$(6 - LEN(HEX$(Paragraph&)), "0"); HEX$(Paragraph&);
COLOR 0, 0
LOCATE 3, 15, 0
PLAY "MF"
Duration$ = "MN"
PLAY Duration$
Octave = 0
PLAY "O0"
SaveRow = CSRLIN
SaveCol = POS(0)
FlagOn:
PLAY "T =" + VARPTR$(Tempo)
PLAY "L =" + VARPTR$(Length)
Start:
SCREEN 0, , 1, 1
VIEW PRINT 3 TO 24
LOCATE SaveRow, SaveCol, 0
IF POS(0) = 39 THEN
    PRINT "   ";
ELSEIF POS(0) = 65 THEN
    IF Colr = 0 THEN
        COLOR 0, 7
    ELSE
        COLOR Colr
    END IF
    LOCATE CSRLIN, 75
    PRINT STRING$(6 - LEN(HEX$(Paragraph&)), "0"); HEX$(Paragraph& + 15);
    COLOR 0, 0
    PRINT
    Lines = Lines + 1
    SaveRow = CSRLIN
    IF Lines = 8 THEN
        PRINT
        Lines = 0
        SaveRow = CSRLIN
    END IF
    Colr = Colr + 1
    IF Colr = 16 THEN
        Colr = 0
    END IF
    IF Colr = 0 THEN
        COLOR 0, 7
    ELSE
        COLOR Colr
    END IF
    Paragraph& = Paragraph& + 16
    Page1TopRow
    LOCATE SaveRow, 1
    PRINT STRING$(6 - LEN(HEX$(Paragraph&)), "0"); HEX$(Paragraph&);
    COLOR 0, 0
    LOCATE SaveRow, 16
ELSE
    PRINT " ";
END IF
A$ = INPUT$(1, # FileName)
Counter& = Counter& + 1
IF LEN(HEX$(ASC(A$))) = 1 THEN
    HighByte$ = "0"
ELSE
    HighByte$ = LEFT$(HEX$(ASC(A$)), 1)
END IF
ColorWithMusic HighByte$
_DELAY Ticks!
LowByte$ = RIGHT$(HEX$(ASC(A$)), 1)
ColorWithMusic LowByte$
_DELAY Ticks!
IF Counter& < LOF(FileName) THEN
    An$ = UCASE$(INKEY$)
    IF LEN(An$) THEN
        SaveRow = CSRLIN
        SaveCol = POS(0)
        IF INSTR("NLS", An$) THEN
            Duration$ = "M" + An$
            PLAY Duration$
        ELSEIF INSTR("01234", An$) THEN
            Octave = VAL(An$)
            Octave$ = "O" + An$
            PLAY Octave$
        ELSE
            DO
                An$ = UCASE$(INKEY$)
                IF LEN(An$) THEN
                    IF INSTR("NLS", An$) THEN
                        Duration$ = "M" + An$
                        PLAY Duration$
                    ELSEIF INSTR("01234", An$) THEN
                        Octave = VAL(An$)
                        Octave$ = "O" + An$
                        PLAY Octave$
                    ELSEIF An$ = CHR$(27) THEN
                        CLOSE
                        SCREEN 0, , 1, 1
                        VIEW PRINT
                        COLOR 7, 0
                        CLS
                        SCREEN 0, , 0, 0
                        VIEW PRINT
                        COLOR 7, 0
                        CLS
                        SYSTEM
                    ELSEIF An$ = CHR$(13) THEN
                        Flag = -1
                        SCREEN 0, , 0, 0
                        GOTO Lab3
                    END IF
                    GOTO Start
                END IF
            LOOP
        END IF
        GOTO Start
    ELSE
        SaveRow = CSRLIN
        SaveCol = POS(0)
        GOTO Start
    END IF
ELSE
    CLOSE
    PRINT CHR$(13)
    LOCATE 24, 40
    COLOR 23, 0
    PRINT CHR$(14);
    WHILE INKEY$ = ""
    WEND
    SCREEN 0, , 1, 1
    COLOR 7, 0
    CLS
    SCREEN 0, , 0, 0
    VIEW PRINT
    COLOR 7, 0
    CLS
    SYSTEM
END IF

SUB ColorWithMusic (Byte$)
SELECT CASE Byte$
    CASE "0"
        COLOR 0, 7
        PRINT "0";
        PLAY "N0"
        COLOR 0, 0
    CASE "1"
        COLOR 1, 0
        PRINT "1";
        PLAY "C"
    CASE "2"
        COLOR 2, 0
        PRINT "2";
        PLAY "C#"
    CASE "3"
        COLOR 3, 0
        PRINT "3";
        PLAY "D"
    CASE "4"
        COLOR 4, 0
        PRINT "4";
        PLAY "D#"
    CASE "5"
        COLOR 5, 0
        PRINT "5";
        PLAY "E"
    CASE "6"
        COLOR 6, 0
        PRINT "6";
        PLAY "F"
    CASE "7"
        COLOR 7, 0
        PRINT "7";
        PLAY "F#"
    CASE "8"
        COLOR 8, 0
        PRINT "8";
        PLAY "G"
    CASE "9"
        COLOR 9, 0
        PRINT "9";
        PLAY "G#"
    CASE "A"
        COLOR 10, 0
        PRINT "A";
        PLAY "A"
    CASE "B"
        COLOR 11, 0
        PRINT "B";
        PLAY "A#"
    CASE "C"
        COLOR 12, 0
        PRINT "C";
        PLAY "B"
    CASE "D"
        COLOR 13, 0
        PRINT "D";
        PLAY ">"
        PLAY "C"
        PLAY "<"
    CASE "E"
        COLOR 14, 0
        PRINT "E";
        PLAY ">"
        PLAY "C#"
        PLAY "<"
    CASE "F"
        COLOR 15, 0
        PRINT "F";
        PLAY ">"
        PLAY "D"
        PLAY "<"
END SELECT
_DELAY .05
END SUB

SUB Page1TopRow
VIEW PRINT
IF Colr = 16 THEN
    Colr = 0
END IF
IF Colr = 0 THEN
    COLOR 0, 7
ELSE
    COLOR Colr
END IF
LOCATE 1, 16
PRINT "00 01 02 03 04 05 06 07   08 09 0A 0B 0C 0D 0E 0F";
IF Colr = 0 THEN
    COLOR 7, 0
END IF
LOCATE 2, 16
PRINT STRING$(23, 205); "   "; STRING$(23, 205);
VIEW PRINT 3 TO 24
IF Colr = 0 THEN
    COLOR 0, 7
END IF
END SUB




